\documentclass[pdf,contemporain,colorBG,slideColor]{prosper}
%\documentclass{powersem}


\usepackage{color}
\usepackage{epsfig}
\usepackage{pause}
\usepackage{background}
\usepackage{mpmulti}
\usepackage{hyperref}
%\usepackage{soul}
\usepackage[display,oldfiltering]{texpower}


\usepackage{pst-grad}
\usepackage{pst-text}
\usepackage{pst-char}
\usepackage{pst-node}

\definecolor{orange}{rgb}{1,0.64,0}
\definecolor{transistioncolor}{rgb}{0,0.9,0}
\definecolor{backcolor}{rgb}{1,1,1}
\definecolor{backgroundcolor}{rgb}{0.2,0.36,0.77}
%\definecolor{darkblue}{rgb}{0,0,0.6}
\definecolor{forecolor}{rgb}{0,0,0.5}
\definecolor{relaxedforecolor}{rgb}{0.8,0.8,0.8}
\definecolor{activeforecolor}{rgb}{1,1,1}
\definecolor{shadowcolor}{rgb}{0.2,0.2,0.7}
\definecolor{blockcolor}{rgb}{0.9,0.9,1}

\ptsize{10}

\title{FORK}
\subtitle{Communication in the ODIN robot}
\email{tobibobi@gmail.com}
\author{Peter Tobias G\o nge Nielsen}
\institution{
  M\ae rsk Mc-Kinney M\o ller Institute \\
  University of Southern Denmark
}
\slideCaption{Communication}
\DefaultTransition{Replace}

\Logo(-1cm,-1.3cm){\epsfig{file=pics/800px-Odin,width=2cm}}

\def\slideTextSize{9}

\begin{document}
%\pageDuration{1}

\def\dim#1{%
  \rput[lm](0,0.2\baselineskip){\textcolor{relaxedforecolor}{#1}}
}

\def\act#1{%
  \rput[lm](0,0.2\baselineskip){\textcolor{activeforecolor}{#1}}
}


\def\highlight#1#2{%
  \dim{#2}%
  \onlySlide{#1}{\act{#2}}%
}

\def\highlightUntil#1#2{%
  \dim{#2}%
  \untilSlide{#1}{\act{#2}}%
}

\def\highlightFrom#1#2{%
  \dim{#2}%
  \fromSlide{#1}{\act{#2}}%
}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------

\maketitle


%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------
\overlays{2}{
\begin{slide}{Focus for this presentation}
\ptsize {\slideTextSize}
\begin{itemize}
\item Support the report.
\item Discuss new ideas.
\item Future work.
\end{itemize}
\FromSlide{2}
\subsection*{For the thesis (not now)}
A more abstract presentation.
\end{slide}}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------

\begin{slide}{Overview}
\ptsize {\slideTextSize}
Contents:
\begin{itemize}
\item Description of the environment.
\item Defining algorithms
\item Elaborating on (some) algorithms.
  \begin{itemize}
  \item Token network
  \item Global network
  \item Hybrid network
  \end{itemize}
\item Future work
\end{itemize}
\end{slide}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------


\overlays{3}{
\begin{slide}{Description of the environment}
\ptsize {\slideTextSize}
\subsection*{The module}
\begin{itemize}
\item \highlightUntil{2}{Basic communication properties.}\\
\begin{itemize}
\item \highlightUntil{2}{\emph{Not a standard graph.}}\\
\item \highlightUntil{2}{\emph{Current and previous version}}
\end{itemize}
\item \highlightFrom{3}{Abstraction levels}
\end{itemize}
\begin{pspicture}(0,3)
\psset{linecolor=white,linewidth=0.1pt}
\rput(6.2,-0.2){\psframe*[linecolor=shadowcolor](5,5){}}
\rput(6,0){\psframe*[linecolor=blockcolor](5,5){}}
\onlySlide{1}{\rput[cm](8.5,2.5){\epsfig{file=fig/communication_between_modules1,width=4cm}}}
\onlySlide{2}{\rput[cm](8.5,2.5){\epsfig{file=fig/communication_between_modules2,width=4cm}}}
\onlySlide{3}{\rput[cm](8.5,2.5){\epsfig{file=ink/layers,width=4.5cm}}}
\end{pspicture}
\end{slide}
}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------
\overlays{4}{
\begin{slide}{Defining algorithms}
\ptsize {\slideTextSize}
\section*{The state machine.}
\begin{itemize}
\item \highlight{1}{The basic form}
\item \highlightFrom{2}{Transitions}
\end{itemize}
\rput(9,0){
\begin{pspicture}(6,6)
%  \psframe[linecolor=white,linewidth=0.1pt](6,6){}
  \psset{linecolor=white,fillcolor=white,nodesep=1pt}
  \rput(1,2){\cnode*{0.15}{root}}
  \rput[cm](1,1){\circlenode{A}{\small $\mathbf{S_1}$}}
  \rput[cm](3,1){\circlenode{B}{\small $\mathbf{S_2}$}}
  \rput[cm](3,3){\circlenode[fillcolor=green]{C}{\small
      $\mathbf{S_3}$}} \rput[cm](3,5){\circlenode{D}{\small
      $S_4$}} \psset{fillcolor=backgroundcolor,linecolor=transistioncolor}
  \ncline[linewidth=2pt]{->}{root}{A}
  
  \ncline[linewidth=2pt]{->}{A}{B}
  \fromSlide{2}{\ncput*{\tiny $A_1$}}
  \ncline[linewidth=2pt]{->}{B}{C}
  \fromSlide{3}{\ncput*{\tiny $R^{\rightarrow}_{(MSG1)}$}}
  \ncline[linewidth=2pt]{->}{C}{D}
  \fromSlide{3}{\ncput*{\tiny $T^{\leftarrow}_{(MSG2)}$}}
\end{pspicture}}


\begin{minipage}{6cm}
\onlySlide*{3}{
$T^{\rnode{A}{\rightarrow}}_{(MSG)}, \qquad T^{\leftarrow}_{(MSG)}$\\
$R^{\rnode{AA}{\rightarrow}}_{(MSG)} \qquad  R^{\leftarrow}_{(MSG)}$\\
\vspace{0.1cm}\\
}
\fromSlide{4}{
$T^{\rnode{A}{\rightarrow}}_{(...)}, \qquad \dim{T^{\leftarrow}_{(MSG)}}$\\
$R^{\rnode{AA}{\rightarrow}}_{(...)} \qquad  \dim{R^{\leftarrow}_{(MSG)}}$\\
\vspace{0.1cm}\\
\rnode{rr}{Communication direction.}
\ncarc[linecolor=red,arcangle=-60,linewidth=2pt]{->}{rr}{A}
\ncarc[linecolor=red,linewidth=2pt]{->}{rr}{AA}
}
\end{minipage}

\end{slide}}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------

\part{Elaboration on (some) algorithms}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------


% Questions for my self for this slide:
% how do i get from motivation to implementation?


\overlays{4}{
\begin{slide}{Token network}
\ptsize {\slideTextSize}
\begin{minipage}{5.5cm}
\subsection*{Token network}
\begin{itemize}
\item \highlight{1}{Motivation}
\item \highlight{2}{Traditional token network}

\highlight{2}{\emph{As referenced by Distributed Algorithms.}}
\item \highlight{3}{Multipoint variant}
\end{itemize}
\fromSlide{4}{
\subsection*{Differencies between the two\\approaches}
\begin{itemize}
\item Traditional nets need a start.
\item Multipoint nets need an order.
\end{itemize}
}
\end{minipage}
\quad\begin{minipage}{4.9cm}
\onlySlide*{1}{
\begin{itemize}
\item Communication happens without unexpected time delay (real time).
\item Collisions are bad for performance.
\item Running time $O(n)$ for $n$ modules in a token network.
\item Node presence awareness?
\end{itemize}
}
\onlySlide*{2}{
\begin{pspicture}(5,2)
%\psframe(5,4.5){}
\psset{linecolor=white,linewidth=1pt}
\rput[cm](2.5,2.5){Traditional token network}
\rput(0,-1){
\rput[cm](2,0.5){\cnode{0.15}{A1}}
\rput[cm](3,0.5){\cnode{0.15}{A2}}
\rput[cm](3.5,1.05){\cnode{0.15}{A3}}
\rput[cm](3.5,1.95){\cnode{0.15}{A4}}
\rput[cm](3,2.5){\cnode{0.15}{A5}}
\rput[cm](2,2.5){\cnode{0.15}{A6}}
\rput[cm](1.5,1.95){\cnode{0.15}{A7}}
\rput[cm](1.5,1.15){\cnode{0.15}{A8}}
}
\psset{linecolor=transistioncolor,linewidth=2pt}
\ncarc{->}{A2}{A1}
\ncarc{->}{A3}{A2}
\ncarc{->}{A4}{A3}
\ncarc{->}{A5}{A4}
\ncarc{->}{A6}{A5}
\ncarc{->}{A7}{A6}
\ncarc{->}{A8}{A7}
\ncarc{->}{A1}{A8}
\end{pspicture}}
\onlySlide*{3}{
\begin{pspicture}(5,2)
\rput[cm](2.5,2.5){Multipoint token network}
\psset{linecolor=white,linewidth=1pt}
\rput(0,-1.5){
\rput[cm](2,0.95){\circlenode{A5}{5}}
\rput[cm](3,0.95){\circlenode{A2}{2}}
\rput[cm](3.55,1.55){\circlenode{A7}{7}}
\rput[cm](3.55,2.45){\circlenode{A3}{3}}
\rput[cm](3,3.05){\circlenode{A1}{1}}
\rput[cm](2,3.05){\circlenode{A6}{6}}
\rput[cm](1.45,2.45){\circlenode{A4}{4}}
\rput[cm](1.45,1.55){\circlenode{A8}{8}}
}
\psset{linecolor=transistioncolor,linewidth=1.5pt}
\ncline{->}{A2}{A1}
\ncline{->}{A3}{A2}
\ncline{->}{A4}{A3}
\ncline{->}{A5}{A4}
\ncline{->}{A6}{A5}
\ncline{->}{A7}{A6}
\ncline{->}{A8}{A7}
\ncline{->}{A1}{A8}
\end{pspicture}
}
\vspace{1.5cm}
\end{minipage}
\end{slide}
}


%% \begin{slide}{Token network (2/2)}
%% \ptsize {\slideTextSize}
%% \begin{pspicture}(12,8)
%% \psset{fillcolor=backgroundcolor,linecolor=white,arcangle=-16}
%%   \rput(0.2,2.1) {
%%     \rput(0,4.5){\cnode*{0.15}{root}}
%%     \rput(1,4){\circlenode{NC}{\small\bf nc}}
%%     \rput(5,5.5){\circlenode{I}{\small\bf init}}
%%     \rput(5,2.5){\circlenode{W}{\small\bf wait}}
%%     \rput(2.5,0){\circlenode{C}{\small\bf cnf}}
%%     \rput(9,4.5){\circlenode[fillcolor=green]{S}{\small\bf slv}}
%%     \rput(9,0.5){\circlenode[fillcolor=green]{T}{\small\bf tkn}}
%%     \psset{fillstyle=none,linecolor=white,arcangle=-20,nodesep=1.5pt,linecolor=transistioncolor,linewidth=2pt}
%%     \ncline{->}{root}{NC}
%%     \nccircle[angle=165]{->}{NC}{0.5}
%%     \nbput*{\small \parbox{1.2cm}{\centering $A_0$,\\ $T_{(PING)}$}}

%%     \ncline{->}{NC}{I}
%%     \naput*[nrot=:U]{\small \parbox{1.8cm}{$A_1$,\\$R_{(PING)}$ or\\$R_{(PING\_REPLY)}$}}
    
%%     \ncline{->}{I}{W}
%%     \ncput*{\small $A_2$, $T_{(ID)}$}

%%     \ncline{->}{W}{NC}
%%     \ncput*{\small $A_{11}$}

%%     \ncarc[arcangle=20]{<-}{C}{W}
%%     \naput*[nrot=:U]{\small $A_9$, $T_{(ID\_CONF)}$}

%%     \ncarc[linecolor=transistioncolor,linewidth=2pt]{->}{C}{W}
%%     \nbput*[nrot=:U]{\small $A_{10}$, $T_{(ID)}$}

%%     \ncline[linecolor=transistioncolor,linewidth=2pt]{->}{W}{S}
%%     \ncput*{\small $A_7$}

%%     \ncline[linecolor=transistioncolor,linewidth=2pt]{->}{W}{T}
%%     \ncput*{\small $A_3$}

%%     \nccircle[angleA=220]{->}{T}{0.5}
%%     \ncput*{\small $A_4$}

%%     \ncarc{->}{S}{T}
%%     \nbput*{\small \parbox{1.4cm}{\raggedleft$A_6$,\\$R_{(TOKEN)}$}}

%%     \ncarc{->}{T}{S}
%%     \nbput*{\small \parbox{1.1cm}{$A_5$,\\$T_{(TOKEN)}$}} 

%%     \ncdiag[angleA=90,angleB=90,linearc=0.5,armA=1.55,armB=2.1]{->}{S}{NC}
%%     \ncput*{\small $A_{12}$}

%%     \nccircle[angle=280]{->}{S}{0.45}
%%     \nbput*{\small \parbox{1.1cm}{$A_8$,\\$R_{(TOKEN)}$}}
%%   }
%% \end{pspicture}
%% \end{slide}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------

\overlays{4}{
\begin{slide}{Global algorithm (1/3)}
\ptsize {\slideTextSize}
\subsection*{Goals}
\begin{itemize}
\item All modules connected in one spanning net.

  \emph{Motivated by Ricardo Franko Mendoza}
\item To be able to withstand modifications in the grid (maybe)
\end{itemize}
\hspace{0.5cm}\fromSlide{2}{\textcolor{red}{But no guarantee that the
    path will be optimal}}
\fromSlide{3}{ - only maybe.}

\hspace{0.5cm}\fromSlide{4}{\emph{Currently I am able to build a total network.}}
\end{slide}}


%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------

\begin{slide}{Global algorithm (2/3)}
\ptsize {\slideTextSize}
\subsection*{Redefining the loop problem}
\begin{pspicture}(9,5)
\rput(1.2,0){\psframe*[linecolor=shadowcolor](8.5,4.5){}}
\rput(1,0.2){\psframe*[linecolor=blockcolor](8.5,4.5){}}
\rput[mb](5.45,0.4){\epsfig{file=fig/global,height=4cm}}
\end {pspicture}
\end{slide}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------

\begin{slide}{Global algorithm (3/3)}
\ptsize {\slideTextSize}
\begin{minipage}{4.2cm}
\subsection*{Algorithm:}
\scalebox{0.55}{
\begin{pspicture}(8,9.5)
  %\psframe(8,9.5){}
  \psset{linecolor=white}
  \rput(-1,-1){
  \rput(1.5,8.5){\cnode*{0.15}{root}}
  \rput[cm](4,8.5){\circlenode{A}{\small\bf noth}}
  \rput[cm](4,6){\circlenode{B}{\small\bf eval}}
  \rput[cm](6,1.5){\circlenode{C}{\small\bf comp}}
  }
  \psset{linecolor=transistioncolor,fillcolor=backgroundcolor,linewidth=2pt,fillstyle=none,nodesep=2pt}

  \ncarc{->}{A}{B}
  \naput*{\parbox{1.1cm}{\small $R^{\leftarrow}_{(GT)}$\\$T^{\rightarrow}_{(AHG)}$}}
  \ncarc{->}{B}{A}
  \naput*{\small $\mathbf{T^{\rightarrow}_{(GT)}}$}

  \ncarc[arcangleB=-90,arcangleA=-45]{->}{B}{C}
  \ncput*{\parbox{1.1cm}{\small $R^{\rightarrow}_{(ITG)}$\\$T^{\rightarrow}_{(ITG)}$}}
  \ncline{->}{B}{C}
  \ncput*{\parbox{1.1cm}{\small $R^{\rightarrow}_{(AHG)}$\\$T^{\rightarrow}_{(ITG)}$}}

  \ncarc[arcangle=-65]{->}{C}{B}
  \ncput*{\parbox{2cm}{\small $v>v_{foreign}$\\$T^{\leftarrow}_{(AHG)}$}}
  \ncarc[arcangle=-90,arcangleA=-110,nodesep=5pt]{->}{C}{A}
  \ncput*{\small $v<v_{foreign}$}

  \nccircle{->}{A}{0.5}
  \nbput*{\parbox{1.1cm}{\small $R^{\leftarrow}_{(AHG)}$\\$T^{\leftarrow}_{(ING)}$}}
  \nccircle[angleA=90]{->}{B}{0.5}
  \nbput*{\small $R^{\rightarrow}_{(INGC)}$}

  \ncline{->}{root}{A}
\end{pspicture}
}
\end{minipage}
\begin{minipage}{5cm}
\subsection*{Messages:}
\begin{tabular}{ll}
\emph{Message}               & \emph{Short desc} \\
\hline
\small GROW\_TREE                   & GT \\ 
\small ASK\_HAS\_GLOBAL             & AHG \\
\small IS\_NOT\_GLOBALLY\_CONNECTED & INGC \\
\small INTERRUPT\_THREE\_GROWTH     & ITG \\
\end{tabular}
\end{minipage}
\end{slide}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------
\overlays{4}{
\begin{slide}{Hybrid algorithm (1/3)}
\ptsize {\slideTextSize}
\subsection*{Features}
\begin{itemize}
\item \highlight{1}{Connect \emph{two} not locally connected objects.}
\item \highlight{2}{Gradient based approach.}
\end{itemize}
\FromSlide{3}
\subsection*{Problems}
\begin{itemize}
\item \highlight{3}{Once built, it cannot alter its graph.}
\item \highlight{4}{Can only attach two modules.}
\end{itemize}
\end{slide}
}


%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------

\begin{slide}{Hybrid algorithm (2/3)}
\begin{minipage}{7cm}
\subsection*{The algorithm}
\scalebox{0.8}{
\begin{pspicture}(11.4,7)
\psset{linecolor=white,nodesep=2pt}
%\psframe(11.4,7){}
\rput(1.2,1){
\rput(0.3,5.5){\cnode*{0.15}{root}}
\rput(1.5,4){\circlenode{idle}{\small\bf idle}}
\rput(4.5,3.5){\circlenode{seek}{\small\bf seek}}
\rput(4.5,1){\circlenode{wait}{\small\bf wait}}
%\rput(7.5,1){\circlenode{open}{\small\bf resolve}}
%\pnode(11,1){next}
}
\psset{linecolor=transistioncolor,linewidth=2pt,fillstyle=none,fillcolor=backgroundcolor}
\nccircle[fillstyle=none,angleA=-20]{->}{idle}{0.4}
\nbput*{\parbox{1.2cm}{\small $R^{\leftarrow}_{(BUILD)}$\\$T^{\rightarrow}_{(BUILD)}$}}

\nccircle[fillstyle=none,angleA=110]{->}{idle}{0.4}
\nbput*{\parbox{2.2cm}{\raggedleft \small $R^{\leftarrow}_{(BUILD)}$\\$netId=myId$:\\$T^{\leftarrow}_{(SEEK)}$}}
\ncline{->}{root}{idle}
\ncline{->}{idle}{seek}
\ncput*{\small $R^{\leftarrow}_{(SEEK)}$}
\ncline{->}{seek}{wait}
\ncput*{\small $T^{\leftarrow}_{(HAS)}$}
\nccircle[angleA=180]{->}{wait}{0.5}
\nbput*{\small $R^{\leftarrow}_{(HAS)}$}
\ncline{->}{wait}{idle}
\ncput*{\small not best}
\ncarc[arcangle=50]{->}{wait}{idle}
\naput*{\parbox{1.1cm}{\small best\\$T^{\rightarrow}_{(SEEK)}$}}
%\ncline[linestyle=dotted]{->}{open}{next}
%\nBput*{\small $T^{\rightarrow}_{SEEK}$}
\end{pspicture}
}
\end{minipage}\quad
\begin{minipage}{3cm}
%\psframe(3,1){}
\rput[lb](0,0){\begin{tabular}{c}
\small \emph{Messages}\\
\hline
\small BUILD \\
\small SEEK\\
\small HAS
\end{tabular}}
\end{minipage}
\end{slide}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------
\overlays{4}{
\begin{slide}{Hybrid algorithm (3/3)}
\ptsize {\slideTextSize}
\begin{minipage}{6.1cm}
\subsection*{Interesting modifications to the hybrid\\ approach}
\begin{itemize}
\item \highlightUntil{2}{Continues routing with pheromones.}
\item \highlightFrom{3}{Time slotted nets.}
\FromSlide{3}
\begin{itemize}
\item \highlight{3}{Current situation}
\item \highlightFrom{4}{Alternative approach}
\end{itemize}
\end{itemize}
\end{minipage}
\qquad
\begin{minipage}{4cm}
\begin{pspicture}(4,3.5)
\rput(0.2,0){\psframe*[linecolor=shadowcolor](3.8,3.3){}}
\rput(0,0.2){\psframe*[linecolor=blockcolor](3.8,3.3){}}
\onlySlide{1}{\rput(1.9,1.85){\epsfig{file=fig/hybrid-model1,width=3.5cm}}}
\onlySlide{2}{\rput(1.9,1.85){\epsfig{file=fig/hybrid-model2,width=3.5cm}}}
\onlySlide{3}{\rput(1.9,1.85){\epsfig{file=fig/hybrid-errors,width=3.5cm}}}
\onlySlide{4}{\rput(1.9,1.85){\epsfig{file=fig/hybrid-errors2,width=3.5cm}}}
\end{pspicture}
\end{minipage}
\end{slide}
}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------

\begin{slide}{Future work (1/2)}
\ptsize {\slideTextSize}
\subsection*{Practical goals}
\begin{itemize}
\item Transferring the algorithms to the robot.  

  \emph{Currently we are starting the process of using eCos on the new
    modules.}
\item Make tests.

  \emph{I am mainly concerned here with tests that shows timing and
    tests to show functional properties. \\Example: do the global
    algorithm build a full net with all members?}
\end{itemize}
\end{slide}

\begin{slide}{Future work (2/2)}
\ptsize {\slideTextSize}
\subsection*{Functional goals}
\begin{itemize}
\item Hybrid algorithm: 
  \begin{itemize}
  \item (High priority) Make sure the algorithm can survive
    configuration changes.
  \item (Medium priority) Implement time slotting in order to allow
    cross communication.
  \end{itemize}  
\item Global algorithm:
  \begin{itemize}
    \item (Low to medium priority) Make sure that the algorithm can
    survive configuration changes.
  \end{itemize}
\item (Low priority) Modifying the algorithms to use a better state machine.
\end{itemize}
\end{slide}

%\stopAdvancing

\part{End.}

%------------------------------------------------------
%                        SLIDE
%------------------------------------------------------
%\pageDuration{0}
%\overlays{3}{
%\begin{slide}{Basics for communication}
%\section*{Representing the robot}
%\onlySlide*{1}{\epsfig{file=fig/communication_between_modules1,width=3cm}}
%\onlySlide*{2}{\epsfig{file=fig/communication_between_modules1,width=2.5cm}}
%\onlySlide*{3}{\epsfig{file=fig/communication_between_modules1,width=2cm}}

%\end{slide}
%}

%\stopAdvancing

\end{document}
